"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CodeTabTree = void 0;
const react_1 = __importStar(require("react"));
const classnames_1 = __importDefault(require("classnames"));
const ui_tree_file_tree_1 = require("@teambit/ui.tree.file-tree");
const ui_tree_drawer_1 = require("@teambit/ui.tree.drawer");
const ui_tree_tree_node_1 = require("@teambit/ui.tree.tree-node");
const ui_tree_folder_tree_node_1 = require("@teambit/ui.tree.folder-tree-node");
const ui_utils_get_file_icon_1 = require("@teambit/ui.utils.get-file-icon");
const base_ui_graph_tree_tree_context_1 = require("@teambit/base-ui.graph.tree.tree-context");
const ui_hooks_use_code_params_1 = require("@teambit/ui.hooks.use-code-params");
const documenter_ui_label_1 = require("@teambit/documenter.ui.label");
const ui_dependency_tree_1 = require("@teambit/ui.dependency-tree");
const code_tab_tree_module_scss_1 = __importDefault(require("./code-tab-tree.module.scss"));
function CodeTabTree({ className, fileTree, dependencies, currentFile = '', devFiles, mainFile, fileIconMatchers, }) {
    const [openDrawerList, onToggleDrawer] = react_1.useState(['FILES' /* , 'DEPENDENCIES' */]);
    const handleDrawerToggle = (id) => {
        const isDrawerOpen = openDrawerList.includes(id);
        if (isDrawerOpen) {
            onToggleDrawer((list) => list.filter((drawer) => drawer !== id));
            return;
        }
        onToggleDrawer((list) => list.concat(id));
    };
    const TreeNodeRenderer = react_1.useCallback(function TreeNode(props) {
        const urlParams = ui_hooks_use_code_params_1.useCodeParams();
        const children = props.node.children;
        const { selected } = react_1.useContext(base_ui_graph_tree_tree_context_1.TreeContext);
        const version = urlParams.version ? `?version=${urlParams.version}` : '';
        const href = `/${urlParams.componentId}/~code/${props.node.id}${version}`;
        const widgets = getWidgets(props.node.id, mainFile, devFiles);
        if (!children) {
            return (react_1.default.createElement(ui_tree_tree_node_1.TreeNode, Object.assign({ href: href }, props, { isActive: props.node.id === selected, icon: ui_utils_get_file_icon_1.getFileIcon(fileIconMatchers, props.node.id), widgets: widgets })));
        }
        return react_1.default.createElement(ui_tree_folder_tree_node_1.FolderTreeNode, Object.assign({}, props));
    }, [fileIconMatchers, devFiles]);
    return (react_1.default.createElement("div", { className: classnames_1.default(code_tab_tree_module_scss_1.default.codeTabTree, className) },
        react_1.default.createElement(ui_tree_drawer_1.DrawerUI, { isOpen: openDrawerList.includes('FILES'), onToggle: () => handleDrawerToggle('FILES'), name: "FILES", className: classnames_1.default(code_tab_tree_module_scss_1.default.codeTabDrawer) },
            react_1.default.createElement(ui_tree_file_tree_1.FileTree, { TreeNode: TreeNodeRenderer, files: fileTree || [''], selected: currentFile })),
        react_1.default.createElement(ui_tree_drawer_1.DrawerUI, { isOpen: openDrawerList.includes('DEPENDENCIES'), onToggle: () => handleDrawerToggle('DEPENDENCIES'), className: classnames_1.default(code_tab_tree_module_scss_1.default.codeTabDrawer), name: "DEPENDENCIES" },
            react_1.default.createElement(ui_dependency_tree_1.DependencyTree, { dependenciesArray: dependencies }))));
}
exports.CodeTabTree = CodeTabTree;
function getWidgets(fileName, mainFile, devFiles) {
    if (fileName === mainFile) {
        return [() => createLabel('main')];
    }
    if (devFiles === null || devFiles === void 0 ? void 0 : devFiles.includes(fileName)) {
        return [() => createLabel('dev')];
    }
    return null;
}
function createLabel(str) {
    return react_1.default.createElement(documenter_ui_label_1.Label, { className: code_tab_tree_module_scss_1.default.label }, str);
}
//# sourceMappingURL=code-tab-tree.js.map